#ifndef Laser_H
#define Laser_H

#include <Vec2.h>
#include <Bild.h>
#include <Welt2D.h>

using namespace Framework;

class Karte;

class Laser : public Object2D
{
private:
	int id;
	double intensitt;
	double startIntensitt;
	int tf;
	int sNum;
	// privat
	char getOutCode( Punkt& p, Bild &zrObj ) const;

public:
	// Konstruktor
	Laser( int id, Vec2< double > pos, Vec2< double > speed, int sNum, double intensitt, int tf );
	// nicht constant
    Rect2< float > getBoundingBox() const;
	bool tick( const WeltInfo &info, double tv ) override;
	void render( Mat3< float > &kamMat, Bild &zRObj ) override;
	// constant
	int getId() const;
	int getSpieler() const;
	double getIntensitt( Vec2< double > targetSpeed ) const;
	// Reference Counting
	Laser *getThis();
	Laser *release();
};

#endif