#include "DeadPlayer.h"
#include "../Define.h"
#include <Textur2D.h>
#include <Bild.h>

DeadPlayer::DeadPlayer( Model2DData *mda, Model2DData *mdb, Punkt posa, Punkt posb, Vertex speedA, Vertex speedB, float curRotA, float curRotB, float rotA, float rotB, Textur2D *zTextur )
    : Object2D()
{
    m2a = new Model2DObject();
    m2a->setModel( mda );
    m2a->setPosition( posa );
    m2a->setTextur( zTextur->getThis() );
    m2a->setDrehung( curRotA );
    m2b = new Model2DObject();
    m2b->setModel( mdb );
    m2b->setPosition( posb );
    m2b->setTextur( zTextur->getThis() );
    m2b->setDrehung( curRotB );
    this->speedA = speedA;
    this->speedB = speedB;
    this->rotA = rotA;
    this->rotB = rotB;
    alpha = 255;
}

DeadPlayer::~DeadPlayer()
{
    m2a->release();
    m2b->release();
}

void DeadPlayer::render( Mat3< float > &kamMat, Bild &zRObj )
{
    zRObj.setAlpha( (unsigned char)alpha );
    m2a->render( kamMat, zRObj );
    m2b->render( kamMat, zRObj );
    zRObj.releaseAlpha();
}

bool DeadPlayer::tick( const WeltInfo &info, double zeit )
{
    m2a->tick( info, zeit );
    m2b->tick( info, zeit );
    alpha -= zeit * 15;
    if( alpha < 0 )
    {
        alpha = 0;
        return 1;
    }
    return 0;
}

Rect2< float > DeadPlayer::getBoundingBox() const
{
    return Rect2< float >();
}